// C Source File
// Created 4/10/2004; 10:44:20 AM

#define USE_TI89              // Compile for TI-89

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

int t, b, t1, r1, d, a, c, r;
int time, score, health;
int x1,x2,x3,x4,x5,x6,x7,x8,x9,x10;
int y1,y2,y3,y4,y5,y6,y7,y8,y9,y10;
int z1,z2,z3,z4,z5,z6,z7,z8,z9,z10;
int w1,w2,w3,w4,w5,w6,w7,w8,w9,w10;
int i1,i2,i3,i4,i5,i6,i7,i8,i9,i10;
int o1,o2,o3,o4,o5,o6,o7,o8,o9,o10;
int u1,u2,u3,u4,u5,u6,u7,u8,u9,u10;
int p1,p2,p3,p4,p5,p6,p7,p8,p9,p10;
int x, y, sprclr, var, slw, timer;
int xy, stop, move, slow, sw;
int shot, sx, sy, shopping, lvl, sh;
int sx1, sx2, sx3, sy1, sy2, sy3, sh1, sh2, sh3;

static unsigned char block1[]={
0b00111100,
0b01111110,
0b11111111,
0b11111111,
0b11111111,
0b01111110,
0b00111100};

static unsigned char sprite1a[]={
0b00000000,
0b00000000,
0b00011000,
0b00011000,
0b10011001,
0b10111101,
0b11011011,
0b10100101};

static unsigned char bullet[]={
0b00011000,
0b00000000};

static unsigned char clear[]={
0b00000000,
0b00000000,
0b00000000,
0b00000000,
0b00000000,
0b00000000,
0b00000000,
0b00000000};

void shipclr(){
	if(t<=1){
 	 b=1;
  }
  Sprite8 (t1-b, r1-d, 8, clear, LCD_MEM, SPRT_AND);
  Sprite8 (t1+a, r1+c, 8, clear, LCD_MEM, SPRT_AND);
  Sprite8 (t1+a, r1-d, 8, clear, LCD_MEM, SPRT_AND);
  Sprite8 (t1-b, r1+c, 8, clear, LCD_MEM, SPRT_AND);
  a=4;
  b=4;
  c=4;
  d=4;
  sprclr=0;
}


void sprclear(int f){
	if(f==1)
	Sprite8 (x1, y1, 8, clear, LCD_MEM, SPRT_AND);
	if(f==2)
	Sprite8 (x2, y2, 8, clear, LCD_MEM, SPRT_AND);
	if(f==3)
	Sprite8 (x3, y3, 8, clear, LCD_MEM, SPRT_AND);
	if(f==4)
	Sprite8 (x4, y4, 8, clear, LCD_MEM, SPRT_AND);
	if(f==5)
	Sprite8 (x5, y5, 8, clear, LCD_MEM, SPRT_AND);
	if(f==6)
	Sprite8 (x6, y6, 8, clear, LCD_MEM, SPRT_AND);
	if(f==7)
	Sprite8 (x7, y7, 8, clear, LCD_MEM, SPRT_AND);
	if(f==8)
	Sprite8 (x8, y8, 8, clear, LCD_MEM, SPRT_AND);
	if(f==9)
	Sprite8 (x9, y9, 8, clear, LCD_MEM, SPRT_AND);
	if(f==10)
	Sprite8 (x10, y10, 8, clear, LCD_MEM, SPRT_AND);
  if(f==12)
  Sprite8 (sx, sy, 8, clear, LCD_MEM, SPRT_AND);
  if(f==13)
	Sprite8 (i1, o1, 8, clear, LCD_MEM, SPRT_AND);
	if(f==14)
	Sprite8 (i2, o2, 8, clear, LCD_MEM, SPRT_AND);
	if(f==15)
	Sprite8 (i3, o3, 8, clear, LCD_MEM, SPRT_AND);
	if(f==16)
	Sprite8 (i4, o4, 8, clear, LCD_MEM, SPRT_AND);
	if(f==17)
	Sprite8 (i5, o5, 8, clear, LCD_MEM, SPRT_AND);
	if(f==18)
	Sprite8 (i6, o6, 8, clear, LCD_MEM, SPRT_AND);
	if(f==19)
	Sprite8 (i7, o7, 8, clear, LCD_MEM, SPRT_AND);
	if(f==20)
	Sprite8 (i8, o8, 8, clear, LCD_MEM, SPRT_AND);
	if(f==21)
	Sprite8 (i9, o9, 8, clear, LCD_MEM, SPRT_AND);
	if(f==22)
	Sprite8 (i10, o10, 8, clear, LCD_MEM, SPRT_AND);
}

void sprtdsp(void){//displays sprites
if(z1==1){//start of displaying block sprites
	sprclear(1);
	y1=y1+w1;
	Sprite8 (x1, y1, 8, block1, LCD_MEM, A_OR);
}
if(z2==1){
	sprclear(2);
	y2=y2+w2;
	Sprite8 (x2, y2, 8, block1, LCD_MEM, A_OR);
}
if(z3==1){
	sprclear(3);
	y3=y3+w3;
	Sprite8 (x3, y3, 8, block1, LCD_MEM, A_OR);
}
if(z4==1){
	sprclear(4);
	y4=y4+w4;	
	Sprite8 (x4, y4, 8, block1, LCD_MEM, A_OR);
}
if(z5==1){
	sprclear(5);
	y5=y5+w5;
	Sprite8 (x5, y5, 8, block1, LCD_MEM, A_OR);
}
if(z6==1){
	sprclear(6);
	y6=y6+w6;	
	Sprite8 (x6, y6, 8, block1, LCD_MEM, A_OR);
}
if(z7==1){
	sprclear(7);
	y7=y7+w7;	
	Sprite8 (x7, y7, 8, block1, LCD_MEM, A_OR);
}
if(z8==1){
	sprclear(8);
	y8=y8+w8;
	Sprite8 (x8, y8, 8, block1, LCD_MEM, A_OR);
}
if(z9==1){
	sprclear(9);
	y9=y9+w9;
	Sprite8 (x9, y9, 8, block1, LCD_MEM, A_OR);
}
if(z10==1){
	sprclear(10);
	y10=y10+w10;	
	Sprite8 (x10, y10, 8, block1, LCD_MEM, A_OR);
}

  Sprite8 (t, r, 8, sprite1a, LCD_MEM, A_OR);

if(u1==1){//start of displaying block sprites
	sprclear(13);
	o1=o1+p1;
	Sprite8 (i1, o1, 8, block1, LCD_MEM, A_OR);
}
if(u2==1){
	sprclear(14);
	o2=o2+p2;
	Sprite8 (i2, o2, 8, block1, LCD_MEM, A_OR);
}
if(u3==1){
	sprclear(15);
	o3=o3+p3;
	Sprite8 (i3, o3, 8, block1, LCD_MEM, A_OR);
}
if(u4==1){
	sprclear(16);
	o4=o4+p4;	
	Sprite8 (i4, o4, 8, block1, LCD_MEM, A_OR);
}
if(u5==1){
	sprclear(17);
	o5=o5+p5;
	Sprite8 (i5, o5, 8, block1, LCD_MEM, A_OR);
}
if(u6==1){
	sprclear(18);
	o6=o6+p6;	
	Sprite8 (i6, o6, 8, block1, LCD_MEM, A_OR);
}
if(u7==1){
	sprclear(19);
	o7=o7+p7;	
	Sprite8 (i7, o7, 8, block1, LCD_MEM, A_OR);
}
if(u8==1){
	sprclear(20);
	o8=o8+p8;
	Sprite8 (i8, o8, 8, block1, LCD_MEM, A_OR);
}
if(u9==1){
	sprclear(21);
	o9=o9+p9;
	Sprite8 (i9, o9, 8, block1, LCD_MEM, A_OR);
}
if(u10==1){
	sprclear(22);
	o10=o10+p10;	
	Sprite8 (i10, o10, 8, block1, LCD_MEM, A_OR);
}

}


void obj(void){
		xy=random(120)+4;
		if(z1==0){
		w1=random(3)+1;
		x1=xy;
		y1=0;
		z1=1;
		return;
		}
		if(z2==0){
		w2=random(2)+2;
		x2=xy;
		y2=0;
		z2=1;
		return;
		}
		if(z3==0){
		w3=random(3)+1;
		x3=xy;
		y3=0;
		z3=1;
		return;
		}
		if(z4==0){
		w4=random(2)+2;
		x4=xy;
		y4=0;
		z4=1;
		return;
		}
		if(z5==0){
		w5=random(3)+1;
		x5=xy;
		y5=0;
		z5=1;
		return;
		}
		if(z6==0){
		w6=random(2)+2;
		x6=xy;
		y6=0;
		z6=1;
		return;
		}
		if(z7==0){
		w7=random(3)+1;
		x7=xy;
		y7=0;
		z7=1;
		return;
		}
		if(z8==0){
		w8=random(2)+2;
		x8=xy;
		y8=0;
		z8=1;
		return;
		}
		if(z9==0){
		w9=random(3)+1;
		y9=xy;
		y9=0;
		z9=1;
		return;
		}
		if(z10==0){
		w10=random(2)+2;
		x10=xy;
		y10=0;
		z10=1;
		return;
		}
		
		if(u1==0){
		p1=random(3)+1;
		i1=xy;
		o1=0;
		u1=1;
		return;
		}
		if(u2==0){
		p2=random(2)+2;
		i2=xy;
		o2=0;
		u2=1;
		return;
		}
		if(u3==0){
		p3=random(3)+1;
		i3=xy;
		o3=0;
		u3=1;
		return;
		}
		if(u4==0){
		p4=random(2)+2;
		i4=xy;
		o4=0;
		u4=1;
		return;
		}
		if(u5==0){
		p5=random(3)+1;
		i5=xy;
		o5=0;
		u5=1;
		return;
		}
		if(u6==0){
		p6=random(2)+2;
		i6=xy;
		o6=0;
		u6=1;
		return;
		}
		if(u7==0){
		p7=random(3)+1;
		i7=xy;
		o7=0;
		u7=1;
		return;
		}
		if(u8==0){
		p8=random(2)+2;
		i8=xy;
		o8=0;
		u8=1;
		return;
		}
		if(u9==0){
		p9=random(3)+1;
		i9=xy;
		o9=0;
		u9=1;
		return;
		}
		if(u10==0){
		p10=random(2)+2;
		i10=xy;
		o10=0;
		u10=1;
		return;
		}
		
}

void stats(void){//displays stats on side screen
DrawLine (130,0,130,100,A_NORMAL);
printf_xy (135,10,"Score =");
printf_xy (135,20,"           ");
printf_xy (135,20,"%i",score+(time/10));
printf_xy (135,40,"Health =");
printf_xy (135,50,"%i",health);
printf_xy (135,60,"Shift =");
printf_xy (135,70,"Help");
printf_xy (135,80,"Level");
printf_xy (135,90,"%i",lvl);
time=time+1;
shopping=shopping+1;
}

void shop(void){
	score=score+(time/10);
	time=0;
	clrscr();
	shopping=0;
  do{ 
  stats();
  shopping=0;
  time=0;
  	if(score>=6400){
  		if(_rowread(~0b100) & 0b1000){
  		shopping=1;
  		score=score-10000;
  		health=health+800;
  		}
  	printf_xy(0,90,"9 = 500+ Health");
  	}
  	if(score>=3840){
    	if(_rowread(~0b1000) & 0b1000){
  		shopping=1;
  		score=score-3840;
  		health=health+3780;
  		}
  	printf_xy(0,80,"8 = 3780+ health");
  	}
  	if(score>=1920){
    	if(_rowread(~0b10000) & 0b1000){
  		shopping=1;
  		score=score-1920;
  		health=health+1890;
  		}
  	printf_xy(0,70,"7= 1890+ health");
  	}
    if(score>=960){
  		if(_rowread(~0b100) & 0b100){
  		shopping=1;
  		score=score-960;
  		health=health+940;
  		}
  	printf_xy(0,60,"6 = 940+ Health");
  	}
  	if(score>=480){
    	if(_rowread(~0b1000) & 0b100){
  		shopping=1;
  		score=score-480;
  		health=health+470;
  		}
  	printf_xy(0,50,"5 = 470+ health");
  	}
  	if(score>=240){
    	if(_rowread(~0b10000) & 0b100){
  		shopping=1;
  		score=score-240;
  		health=health+230;
  		}
  	printf_xy(0,40,"4 = 230+ health");
  	}
    if(score>=120){
  		if(_rowread(~0b100) & 0b10){
  		shopping=1;
  		score=score-120;
  		health=health+110;
  		}
  	printf_xy(0,30,"3 = 110+ Health");
  	}
  	if(score>=60){
    	if(_rowread(~0b1000) & 0b10){
  		shopping=1;
  		score=score-60;
  		health=health+50;
  		}
  	printf_xy(0,20,"2 = 50+ health");
  	}
  	if(score>=30){
    	if(_rowread(~0b10000) & 0b10){
  		shopping=1;
  		score=score-30;
  		health=health+10;
  		}
  	printf_xy(0,10,"1= 10+ health");
  	}
  	printf_xy(0,0,"SHOP");
	}while(shopping==0);
	shopping=0;
	clrscr();
}


void check(void){//checking ship and block coordinates
	if(r<=y1+5 ){//checks to see if ship came in contact w/ block
		if(r>=y1 ){
			if(t>x1-7){
				if(t<x1+7){
					sprclear(1);
					z1=0;
					y1=100;
	        x1=160;
					health=health-(random(5)+5)*w1;
					printf_xy (135,50,"      ");
				}
			}
		}
	}	
	if(r<=y2+5 ){
		if(r>=y2 ){
			if(t>x2-7){
				if(t<x2+7){
					sprclear(2);
					z2=0;
					y2=100;
					x2=160;
					health=health-(random(5)+5)*w2;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=y3+5 ){
		if(r>=y3 ){
			if(t>x3-7){
				if(t<x3+7){
					sprclear(3);
					z3=0;
					y3=100;
					x3=160;
					health=health-(random(5)+5)*w3;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=y4+5 ){
		if(r>=y4 ){
			if(t>x4-7){
				if(t<x4+7){
					sprclear(4);
					z4=0;
					y4=100;
					x4=160;
					health=health-(random(5)+5)*w4;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=y5+5 ){
		if(r>=y5 ){
			if(t>x5-7){
				if(t<x5+7){
					sprclear(5);
					z5=0;
					y5=100;
					x5=160;
					health=health-(random(5)+5)*w5;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=y6+5 ){
		if(r>=y6 ){
			if(t>x6-7){
				if(t<x6+7){
					sprclear(6);
					z6=0;
					y6=100;
					x6=160;
					health=health-(random(5)+5)*w6;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=y7+5 ){
		if(r>=y7 ){
			if(t>x7-7){
				if(t<x7+7){
					sprclear(7);
					z7=0;
					y7=100;
					x7=160;
					health=health-(random(5)+5)*w7;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=y8+5 ){
		if(r>=y8 ){
			if(t>x8-7){
				if(t<x8+7){
					sprclear(8);
					z8=0;
					y8=100;
					x8=160;
					health=health-(random(5)+5)*w8;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=y9+5 ){
		if(r>=y9 ){
			if(t>x9-7){
				if(t<x9+7){
					sprclear(9);
					z9=0;
					y9=100;
					x9=160;
					health=health-(random(5)+5)*w9;
					printf_xy (135,50,"      ");
				}
			}
		}
	}

		if(r<=y10+5 ){
		if(r>=y10 ){
			if(t>x10-7){
				if(t<x10+7){
					sprclear(10);
					z10=0;
					y10=100;
					x10=160;
					health=health-w10*5;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
		if(r<=o1+5 ){//checks to see if ship came in contact w/ block
		if(r>=o1 ){
			if(t>i1-7){
				if(t<i1+7){
					sprclear(13);
					u1=0;
					o1=100;
	        i1=160;
					health=health-(random(5)+5)*p1;
					printf_xy (135,50,"      ");
				}
			}
		}
	}	
	if(r<=o2+5 ){
		if(r>=o2 ){
			if(t>i2-7){
				if(t<i2+7){
					sprclear(14);
					u2=0;
					o2=100;
					i2=160;
					health=health-(random(5)+5)*p2;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=o3+5 ){
		if(r>=o3 ){
			if(t>i3-7){
				if(t<i3+7){
					sprclear(15);
					u3=0;
					o3=100;
					i3=160;
					health=health-(random(5)+5)*p3;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=o4+5 ){
		if(r>=o4 ){
			if(t>i4-7){
				if(t<i4+7){
					sprclear(16);
					u4=0;
					o4=100;
					i4=160;
					health=health-(random(5)+5)*p4;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=o5+5 ){
		if(r>=o5 ){
			if(t>i5-7){
				if(t<i5+7){
					sprclear(17);
					u5=0;
					o5=100;
					i5=160;
					health=health-(random(5)+5)*p5;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=o6+5 ){
		if(r>=o6 ){
			if(t>i6-7){
				if(t<i6+7){
					sprclear(18);
					u6=0;
					o6=100;
					i6=160;
					health=health-(random(5)+5)*p6;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=o7+5 ){
		if(r>=o7 ){
			if(t>i7-7){
				if(t<i7+7){
					sprclear(19);
					u7=0;
					o7=100;
					i7=160;
					health=health-(random(5)+5)*p7;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=o8+5 ){
		if(r>=o8 ){
			if(t>i8-7){
				if(t<i8+7){
					sprclear(20);
					u8=0;
					o8=100;
					i8=160;
					health=health-(random(5)+5)*p8;
					printf_xy (135,50,"      ");
				}
			}
		}
	}
	if(r<=o9+5 ){
		if(r>=o9 ){
			if(t>i9-7){
				if(t<i9+7){
					sprclear(21);
					u9=0;
					o9=100;
					i9=160;
					health=health-(random(5)+5)*p9;
					printf_xy (135,50,"      ");
				}
			}
		}
	}

		if(r<=o10+5 ){
		if(r>=o10 ){
			if(t>i10-7){
				if(t<i10+7){
					sprclear(22);
					u10=0;
					o10=100;
					i10=160;
					health=health-(random(5)+5)*5;
					printf_xy (135,50,"      ");
				}
			}
		}
	}

	if(t>121){//defines ship boundries
       t=120;
       t1=120;
       a=1;
       }
       if(t<1){
       t=1;
       t1=1;
       b=1;
       }
       if(r>91){
       r=90;	
       r1=90;
       c=1;
       }
       if(r<1){
       r=1;
       r1=1;
       d=1;
       }
	
	if(y1>=100){//defines block's boundries
	z1=0;
	y1=100;
	x1=160;
	}
	if(y2>=100){
	z2=0;
	y2=100;
	x2=160;
	}
	if(y3>=100){
	z3=0;
	y3=100;
	x3=160;
	}
	if(y4>=100){
	z4=0;
	y4=100;
	x4=160;
	}
	if(y5>=100){
	z5=0;
	y5=100;
	x5=160;
	}
	if(y6>=100){
	z6=0;
	y6=100;
	x6=160;
	}
	if(y7>=100){
	z7=0;
	y7=100;
	x7=160;
	}
  if(y8>=100){
	z8=0;
	y8=100;
	x8=160;
	}
	if(y9>=100){
	z9=0;
	y9=100;
	x9=160;
	}
	if(y10>=100){
	z10=0;
	y10=100;
	x10=160;
	}
	if(o1>=100){//defines block's boundries
	u1=0;
	o1=100;
	i1=160;
	}
	if(o2>=100){
	u2=0;
	o2=100;
	i2=160;
	}
	if(o3>=100){
	u3=0;
	o3=100;
	i3=160;
	}
	if(o4>=100){
	u4=0;
	o4=100;
	i4=160;
	}
	if(o5>=100){
	u5=0;
	o5=100;
	i5=160;
	}
	if(o6>=100){
	u6=0;
	o6=100;
	i6=160;
	}
	if(o7>=100){
	u7=0;
	o7=100;
	i7=160;
	}
  if(o8>=100){
	u8=0;
	o8=100;
	i8=160;
	}
	if(o9>=100){
	u9=0;
	o9=100;
	i9=160;
	}
	if(o10>=100){
	u10=0;
	o10=100;
	i10=160;
	}

}


void shtcheck(int sht){//checking bullet and block coordinates
	if(sht==1){
	sy=sy1;
	sx=sx1;
	sh=sh1;
	}
	if(sht==2){
	sy=sy2;
	sx=sx2;
	sh=sh2;
	}
	if(sht==3){
	sy=sy3;
	sx=sx3;
	sh=sh3;
	}
	if(sy<=y1+7 ){//checks to see if bullet came in contact w/ block
		if(sy<=y1+7 ){
			if(sx>x1-3){
				if(sx<x1+3){
					sprclear(1);
					sprclear(12);
					z1=0;
					sh=0;
       	  sx=100;
          sy=160;
					y1=100;
					x1=160;
					score=score+10;
				}
			}
		}
	}	
	if(sy<=y2+7){
		if(sy<=y2+7){
			if(sx>x2-3){
				if(sx<x2+3){
					sprclear(2);
					sprclear(12);
					z2=0;
					sh=0;
       	  sx=100;
          sy=160;
					y2=100;
					x2=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=y3+7 ){
		if(sy<=y3+7 ){
			if(sx>x3-3){
				if(sx<x3+3){
					sprclear(12);
					sprclear(3);
					z3=0;
					sh=0;
       	  sx=100;
          sy=160;
					y3=100;
					x3=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=y4+7 ){
		if(sy<=y4+7 ){
			if(sx>x4-3){
				if(sx<x4+3){
					sprclear(12);
					sprclear(4);
					z4=0;
					sh=0;
       	  sx=100;
          sy=160;
					y4=100;
					x4=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=y5+7 ){
		if(sy<=y5+7 ){
			if(sx>x5-3){
				if(sx<x5+3){
					sprclear(12);
					sprclear(5);
					z5=0;
					sh=0;
       	  sx=100;
          sy=160;
					y5=100;
					x5=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=y6+7 ){
		if(sy<=y6+7 ){
			if(sx>x6-3){
				if(sx<x6+3){
					sprclear(12);
					sprclear(6);
					z6=0;
					sh=0;
       	  sx=100;
          sy=160;
					y6=100;
					x6=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=y7+7 ){
		if(sy<=y7+7 ){
			if(sx>x7-3){
				if(sx<x7+3){
					sprclear(12);
					sprclear(7);
					z7=0;
					sh=0;
       	  sx=100;
          sy=160;
					y7=100;
					x7=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=y8+7 ){
		if(sy<=y8+7 ){
			if(sx>x8-3){
				if(sx<x8+3){
					sprclear(12);
					sprclear(8);
					z8=0;
					sh=0;
       	  sx=100;
          sy=160;
					y8=100;
					x8=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=y9+7 ){
		if(sy<=y9+7 ){
			if(sx>x9-3){
				if(sx<x9+3){
					sprclear(12);
					sprclear(9);
					z9=0;
					sh=0;
       	  sx=100;
          sy=160;
					y9=100;
					x9=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=y10+7 ){
		if(sy<=y10+7 ){
			if(sx>x10-3){
				if(sx<x10+3){
					sprclear(12);
					sprclear(10);
					z10=0;
					sh=0;
       	  sx=100;
          sy=160;
					y10=100;
					x10=160;
					score=score+10;
        }
			}
		}
	}
	if(sy<=o1+7 ){//checks to see if bullet came in contact w/ block
		if(sy<=o1+7 ){
			if(sx>i1-3){
				if(sx<i1+3){
					sprclear(1);
					sprclear(13);
					u1=0;
					sh=0;
       	  sx=100;
          sy=160;
					o1=100;
					i1=160;
					score=score+10;
				}
			}
		}
	}	
	if(sy<=o2+7){
		if(sy<=o2+7){
			if(sx>i2-3){
				if(sx<i2+3){
					sprclear(2);
					sprclear(14);
					u2=0;
					sh=0;
       	  sx=100;
          sy=160;
					o2=100;
					i2=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=o3+7 ){
		if(sy<=o3+7 ){
			if(sx>i3-3){
				if(sx<i3+3){
					sprclear(15);
					sprclear(3);
					u3=0;
					sh=0;
       	  sx=100;
          sy=160;
					o3=100;
					i3=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=o4+7 ){
		if(sy<=o4+7 ){
			if(sx>i4-3){
				if(sx<i4+3){
					sprclear(16);
					sprclear(4);
					u4=0;
					sh=0;
       	  sx=100;
          sy=160;
					o4=100;
					i4=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=o5+7 ){
		if(sy<=o5+7 ){
			if(sx>i5-3){
				if(sx<i5+3){
					sprclear(17);
					sprclear(5);
					u5=0;
					sh=0;
       	  sx=100;
          sy=160;
					o5=100;
					i5=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=o6+7 ){
		if(sy<=o6+7 ){
			if(sx>i6-3){
				if(sx<i6+3){
					sprclear(18);
					sprclear(6);
					u6=0;
					sh=0;
       	  sx=100;
          sy=160;
					o6=100;
					i6=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=o7+7 ){
		if(sy<=o7+7 ){
			if(sx>i7-3){
				if(sx<i7+3){
					sprclear(19);
					sprclear(7);
					u7=0;
					sh=0;
       	  sx=100;
          sy=160;
					o7=100;
					i7=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=o8+7 ){
		if(sy<=o8+7 ){
			if(sx>i8-3){
				if(sx<i8+3){
					sprclear(20);
					sprclear(8);
					u8=0;
					sh=0;
       	  sx=100;
          sy=160;
					o8=100;
					i8=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=o9+7 ){
		if(sy<=o9+7 ){
			if(sx>i9-3){
				if(sx<i9+3){
					sprclear(21);
					sprclear(9);
					u9=0;
					sh=0;
       	  sx=100;
          sy=160;
					o9=100;
					i9=160;
					score=score+10;
				}
			}
		}
	}
	if(sy<=o10+7 ){
		if(sy<=o10+7 ){
			if(sx>i10-3){
				if(sx<i10+3){
					sprclear(22);
					sprclear(10);
					u10=0;
					sh=0;
       	  sx=100;
          sy=160;
					o10=100;
					i10=160;
					score=score+10;
        }
			}
		}
	}


	if(sy<1){//defines bullet boundries
       Sprite8 (sx, sy, 8, clear, LCD_MEM, SPRT_AND);
       sx=100;
       sy=160;
       sh=0;
       }
	if(sht==1){
	sy1=sy;
	sx1=sx;
	sh1=sh;
	}
	if(sht==2){
	sy2=sy;
	sx2=sx;
	sh2=sh;
	}
	if(sht==3){
	sy3=sy;
	sx3=sx;
	sh3=sh;
	}
}
	


void startover(){//defines all variables so that program can start over
	xy=0;
	health=200;
	score=0;
	time=0;
	sprclr=1;
	a=4;
	b=4;
	c=4;
	d=4;
	t=60;
	r=90;
	t1=60;
	r1=90;
	x1=0;
	x2=0;
	x3=0;
	x4=0;
	x5=0;
	x6=0;
	x7=0;
	x8=0;
	x9=0;
	x10=0;
	y1=0;
	y2=0;
	y3=0;
	y4=0;
	y5=0;
	y6=0;
	y7=0;
	y8=0;
	y9=0;
	y10=0;
	z1=-1;
	z2=-1;
	z3=-1;
	z4=-1;
	z5=-1;
	z6=-1;
	z7=-1;
	z8=-1;
	z9=-1;
	z10=-1;
	u1=-1;
	u2=-1;
	u3=-1;
	u4=-1;
	u5=-1;
	u6=-1;
	u7=-1;
	u8=-1;
	u9=-1;
	u10=-1;
	i1=0;
	i2=0;
	i3=0;
	i4=0;
	i5=0;
	i6=0;
	i7=0;
	i8=0;
	i9=0;
	i10=0;
	o1=0;
	o2=0;
	o3=0;
	o4=0;
	o5=0;
	o6=0;
	o7=0;
	o8=0;
	o9=0;
	o10=0;
	stop=0;
	move=0;
	sx=0;
	sy=0;
	sx=0;
	sy=0;
	sx=0;
	sy=0;
	sx=0;
	sy=0;
	sx=0;
	sy=0;
	shopping=0;
	lvl=1;
	clrscr();
OSSetSR (0x0700);
FontSetSys (F_4x6);
}

void level(void){
	if(lvl==1){
		z1=0;
		z2=0;
		z3=0;
		z4=0;
		z5=0;
		z6=0;
	}
	if(lvl==2){
		z7=0;
		z8=0;
	}
	if(lvl==3){
		z9=0;
		z10=0;
		u1=0;
	}
	if(lvl==4){
		u2=0;
		u3=0;
		u4=0;
		u5=0;
	}
		if(lvl==5){
		u6=0;
		u7=0;
		u8=0;
		u9=0;
		u10=0;
  	}
}


void wait(void){
waiting:

	if(_rowread(~0b100000) & 0b1)
	return;
	if(_rowread(~0b1000000) & 0b1){
		if(_rowread(~0b100000) & 0b1){
		stop=1;
		return;
		}
	}
	if(_rowread(~0b1) & 0b10000){
	off();
	}
	if(_rowread(~0b10) & 0b1000000){
	startover();
	return;
	}
		 FontSetSys (F_6x8);
     printf_xy(0,0,"In Game");
  	 
  	 FontSetSys (F_4x6);
  	 printf_xy(0,10,"Catalog = New Game");  
     printf_xy(0,20,"Esc = Quit");
     printf_xy(0,30,"+/- = Contrast");
     printf_xy(0,40,"2nd = Shoot");
     
     FontSetSys (F_6x8);
     printf_xy(0,50,"During Pause");
     
     FontSetSys (F_4x6);
     printf_xy(0,60,"Esc + Apps = Quit");
     printf_xy(0,70,"Apps = Unpause");
     printf_xy(0,80,"Catalog = New Game");
     printf_xy(0,90,"2ND = Off");
     if(_rowread(~0b1000) & 0b1000000){
     startover();
     }
     if(_rowread(~0b10) & 0b100){
     OSContrastDn ();
		 }
     if(_rowread(~0b10) & 0b10){
     OSContrastUp ();
     }
goto waiting;
}

void start(void){
int sta=0;
printf("1");
while(sta<=1000)
sta=sta+1;
sta=0;
printf("2");
while(sta<=1000)
sta=sta+1;
sta=0;
printf("3");
while(sta<=1000)
sta=sta+1;
sta=0;
printf("Start!");
while(sta<=1000)
sta=sta+1;
sta=0;
clrscr();
}

// Main Function
void _main(void){
startover();
level();
start();
top:
		 shot=shot+1;
		 if(_rowread(~0b1000000) & 0b1){
     goto end;	
     }
     if(_rowread(~0b1) & 0b100000){
     clrscr();
   	 wait();
   	 clrscr();
     }
     if(_rowread(~0b100000) & 0b10000000){
			if(sh1==0){
		 	sh1=1;
		 	sx1=t;
		 	sy1=r;
		 	}
     }
     if(_rowread(~0b1) & 0b10000){
      if(sh2==0){
      sh2=1;
		  sx2=t;
		  sy2=r;
      }
     }
     if(_rowread(~0b1) & 0b1000000){
      if(sh3==0){
      sh3=1;
		  sx3=t;
		  sy3=r;
      }
     }
     if(_rowread(~0b1) & 0b1){
     shipclr();
     r1=r;
     r=r-2;	
     move=move+1;
     }
     if(_rowread(~0b1) & 0b10){
     shipclr();
     t1=t;
     t=t-2;
     move=move+1;
     }
		 if(_rowread(~0b1) & 0b100){
     shipclr();
     r1=r;
     r=r+2;	
     move=move+1; 
     }
     if(_rowread(~0b1) & 0b1000){
     shipclr();
     t1=t;
     t=t+2;	
     move=move+1;
     }
     if(_rowread(~0b1000) & 0b1000000){
     startover();
     }
     if(_rowread(~0b10) & 0b100){
     OSContrastDn ();
		 }
     if(_rowread(~0b10) & 0b10){
     OSContrastUp ();
     }
     if(move<=10){
     shipclr();
		 }
		 
		 if(sprclr==1)
		 shipclr();
	 
	 	 if(move<=50)
	 	 shipclr();
	 
     if(stop==1)
     goto end;
		 
		 timer=timer+1;
		 if(timer==500){
		 	lvl=lvl+1;
		 	level();
		 	timer=0;
		 }
		 
		 if(shopping==2500){
		 	shop();
		 	shopping=0;
		 }
		 
		 if(health<1){
		 goto end;
		 }
		 
	if(sh1==1){
	Sprite8 (sx1, sy1, 8, clear, LCD_MEM, SPRT_AND);
	sy1=sy1-1;
	Sprite8 (sx1, sy1, 2, bullet, LCD_MEM, A_OR);
	}
	if(sh2==1){
	Sprite8 (sx2, sy2, 8, clear, LCD_MEM, SPRT_AND);
	sy2=sy2-1;
	Sprite8 (sx2, sy2, 2, bullet, LCD_MEM, A_OR);
	}
  if(sh3==1){
	Sprite8 (sx3, sy3, 8, clear, LCD_MEM, SPRT_AND);
	sy3=sy3-1;
	Sprite8 (sx3, sy3, 2, bullet, LCD_MEM, A_OR);
	}
		 check();
		 shtcheck(1);
		 shtcheck(2);
		 shtcheck(3);
		 sprtdsp();
		 stats();
		 obj();	 
		 
goto top;

end:
     OSSetSR (0x0000);
     clrscr();
     x=20;
     y=45;
     a=0;
     stop=1;
     FontSetSys (F_8x10);
     while(a<=50){
     printf_xy(x,y,"GAMEOVER");
     printf_xy(x,y+20,"Score= %i",score+(time/10));
     a=a+1;
     }
     clrscr();
FontSetSys (F_6x8);
}